-- The following is a description of the sequential machine of 
-- Figure 1-17 in terms of its next state equations.
-- The following state assignment was used:
-- S0-->0; S1-->4; S2-->5; S3-->7; S4-->6; S5-->3; S6-->2

entity SM1_2 is
  port(X,CLK: in bit;
       Z: out bit);
end SM1_2;

architecture Equations1_4 of SM1_2 is
  signal Q1,Q2,Q3: bit;
begin
  process(CLK)
  begin
    if CLK='1' then				-- rising edge of clock
	Q1<=not Q2 after 10 ns;
	Q2<=Q1 after 10 ns;
	Q3<=(Q1 and Q2 and Q3) or ((not X) and Q1 and (not Q3)) or 
            (X and (not Q1) and (not Q2)) after 10 ns;
    end if;
  end process;
  Z<=((not X) and (not Q3)) or (X and Q3) after 20 ns;
end Equations1_4;									

